/*
 * minidatadec: run the whole thing -
 * lexing, parsing, and codegenerating C code
 */

#include <stdio.h>
#include <stdlib.h>

#include "bool.h"
#include "lexer.h"
#include "ast.h"
#include "parser.h"
#include "decs.h"


int main( int argc, char **argv )
{
	if( argc == 1 )
	{
                lexfile = stdin;
	} else if( argc == 2 )
	{
                lexfile = fopen( argv[1], "r" );
                if( lexfile == NULL )
		{
			fprintf( stderr, "datadec: can't open '%s'\n",
				argv[1] );
			exit(1);
		}
        } else
	{
		fprintf( stderr, "Usage: datadec [filename]\n" );
		exit(1);
        }
	declnlist d;
	BOOL ok = parse_declns(&d);
	printf( "parse: %s\n", ok?"success":"failure" );
	if( ok )
	{
		printf( "\nparse tree:\n\n" );
		print_declnlist( stdout, d );

		printf( "\n" );
		make_declns( d, "datatypes" );
	}

	exit(0);
	/*NOTREACHED*/
}
