/*
 * parsetest: test the parser
 */

#include <stdio.h>
#include <stdlib.h>

#include "bool.h"
#include "lexer.h"
#include "ast.h"
#include "parser.h"


int main( int argc, char **argv )
{
	if( argc == 1 )
	{
                lexfile = stdin;
	} else if( argc == 2 )
	{
                lexfile = fopen( argv[1], "r" );
                if( lexfile == NULL )
		{
			fprintf( stderr, "parsetest: can't open '%s'\n",
				argv[1] );
			exit(1);
		}
        } else
	{
		fprintf( stderr, "Usage: parsetest [filename]\n" );
		exit(1);
        }
	declnlist d;
	BOOL ok = parse_declns(&d);
	printf( "parse: %s\n", ok?"success":"failure" );
	if( ok )
	{
		printf( "\nparse tree:\n\n" );
		print_declnlist( stdout, d );
	}

	exit(0);
	/*NOTREACHED*/
}
